<?php
/**
 * @file
 * Provide KBC Paypage form functionalities.
 */

/**
 * Implements hook_form_FORM_ID_alter().
 */
function commerce_kbcpaypage_form_commerce_checkout_form_alter(array &$form, array $form_state) {
  // For each of the KBC Paypage payment methods, display the KBC Paypage icon
  // and small icons of the available payment methods.
  // If this checkout form contains the payment method radios.
  if (!empty($form['commerce_payment']['payment_method']['#options'])) {
    // Loop over its options array looking for a KBC Paypage option.
    foreach ($form['commerce_payment']['payment_method']['#options'] as $key => &$value) {
      $payment_method = explode('|', $key);
      // If we have a KBC Paypage option.
      if ($payment_method[0] == 'kbcpaypage' || $payment_method[0] == 'kbcpaypage_one_page_checkout') {
        module_load_include('inc', 'commerce_kbcpaypage', 'includes/commerce_kbcpaypage.core');
        // Prepare the replacement of radio button text with icons.
        $payment_method_instance = commerce_payment_method_instance_load($key);
        $payment_options = _commerce_kbcpaypage_payment_options($payment_method_instance);
        foreach ($payment_options as &$payment_option) {
          $payment_option = _commerce_kbcpaypage_icon($payment_option);
        }

        // Only show include text when one or more payment options are enabled.
        if (count($payment_options) > 1) {
          $value .= theme('commerce_kbcpaypage_icons', array(
            'payment_options' => $payment_options,
          ));

          // Add the CSS.
          if (!isset($form['commerce_payment']['payment_method']['#attached']['css']) || !in_array(drupal_get_path('module', 'commerce_kbcpaypage') . '/css/commerce_kbcpaypage.css', $form['commerce_payment']['payment_method']['#attached']['css'])) {
            $form['commerce_payment']['payment_method']['#attached']['css'][] = drupal_get_path('module', 'commerce_kbcpaypage') . '/css/commerce_kbcpaypage.css';
          }
        }
      }
    }
  }

  // If a saved cardonfile is selected, remove the payment details and add a
  // Security Code field.
  if (!empty($form['commerce_payment']['payment_details']['cardonfile']['#options'])
      && (empty($form_state['values']['commerce_payment']['payment_details']['cardonfile']) || $form_state['values']['commerce_payment']['payment_details']['cardonfile'] !== 'new')) {
    $form['commerce_payment']['payment_details']['payment_options_kbcpaypage_one_page_checkout']['#access'] = FALSE;
    $form['commerce_payment']['payment_details']['cvc'] = array(
      '#type' => 'textfield',
      '#title' => t('Security code'),
      '#default_value' => '',
      '#attributes' => array('autocomplete' => 'off'),
      '#required' => TRUE,
      '#maxlength' => 4,
      '#size' => 4,
    );
  }
}
