<?php
/**
 * @file
 * Provides the ability to add a 'review payment method' to the Drupal Commerce
 * checkout.
 */

/**
 * Callback for commerce_checkout_pane: return review data.
 *
 * Returns the cart contents review data for the Review checkout pane.
 */
function commerce_kbcpaypage_review(array $form, array $form_state, array $checkout_pane, $order) {
  // Use default payment method if order was not saved yet.
  if (!isset($order->data['payment_method'])) {
    $order->data['payment_method'] = $form['commerce_payment']['payment_method']['#default_value'];
  }

  // Load the payment method.
  $payment_method = commerce_payment_method_load(substr($order->data['payment_method'], 0, strpos($order->data['payment_method'], '|', 0)));

  $theme_array = array(
    'payment' => $payment_method,
  );

  // Load the payment option.
  if (isset($order->data['payment_option'])) {
    module_load_include('inc', 'commerce_kbcpaypage', 'includes/commerce_kbcpaypage.core');
    $payment_options = _commerce_kbcpaypage_payment_options();
    $theme_array['payment_option'] = $payment_options[$order->data['payment_option']]['name'];
  }

  return theme('commerce_kbcpaypage_payment_review', $theme_array);
}
